PROGRAM MouserDemo1;

(***************************************************************)
(*                                                             *)
(*                         Demo1.pas                           *)
(*                                                             *)
(***************************************************************)
(*            A demonstration for the Mouser! unit             *)
(***************************************************************)

USES Mouser55, CRT;

VAR
  OldX,
  OldY     :  Integer;
  Ending   :  Boolean;


PROCEDURE AbortDemo;                      { This occurs if the      }
BEGIN                                     { Mouser! Global Variable }
  Writeln('Mouse Driver not loaded');     { INSTALLED Returns False }
  Writeln('Demo 1 Aborted');
  Blip;
  HALT(1);
END;

PROCEDURE UpdateScreen;

   (*

     Updates the screen information only if the mouse's
     position has changed since the last call to GetMXY

   *)

BEGIN
  IF ((OldX<>MouseX) or (OldY<>MouseY)) THEN
     BEGIN
       HideMouse;  {------------------------------                      }
       GotoXY(26,1); Write(MouseX,'  ');       {    Hiding then showing }
       GotoXY(26,2); Write(MouseY,'  ');       {    the mouse keeps the }
       GotoXY(60,1);Write(((MouseX DIV 8)+1),' '); { mouse cursor from   }
       GotoXY(60,2);Write(((MouseY DIV 8)+1),' '); { being overwritten.  }
       ShowMouse;  {------------------------------   A GOOD PRACTICE    }
     END;
END;

BEGIN
   ClrScr;
   Ending:=FALSE;
   MouseX:=0;
   MouseY:=0;
   IF Not Installed THEN AbortDemo;     (* Mouser Global Variable *)
   GotoXY(17,24);
   Write('Press any key or Mouse button to exit');
   GotoXY(7,1);
   Write('Mouse X Position =       Actual Screen Coordinates =');
   GotoXY(7,2);
   Write('Mouse Y Position =       Actual Screen Coordinates =');
   ShowMouse;

   (*

     Notice how the mouse cursor was turned on LAST, this keeps
     the mouse from affecting writes to the screen, especially
     frustrating in graphics programming.

   *)
 REPEAT
   IF ((Keypressed) or
       (ButtonPressed)) THEN Ending:=TRUE;
   OldX:=MouseX;
   OldY:=MouseY;
   GetMXY;           (* Mouser! Procedure to update MouseX + MouseY *)
   UpdateScreen;
 UNTIL Ending;
  Blip;              (* Mouser! Dual tone beep *)
  HideMouse;
  ClrScr;
  (*

    Even when Clearing the screen, you should
    first remove the mouse from the screen, or,
    at the very least, position the mouse cursor
    to an empty area of the screen with PutMXY

    If Mouser! can not detect your mouse driver and you are sure
    you have it installed, then you can put Installed:=TRUE;
    that should solve the problem.  Mouser! just has difficulty
    in recognizing your type of driver.

  *)
END.


